=== release@v0.12.0/cmd/kubepkg/templates/latest/deb/kubeadm/debian/changelog ===
kubeadm ({{ .Version }}-{{ .Revision }}) {{ .Channel }}; urgency=medium

  * https://git.k8s.io/kubernetes/CHANGELOG/README.md

 -- Kubernetes Authors <kubernetes-dev@googlegroups.com>  {{ date }}
