=== release@v0.12.0/cmd/kubepkg/templates/latest/deb/kubelet/debian/control ===
Source: kubelet
Section: misc
Priority: optional
Maintainer: Kubernetes Authors <kubernetes-dev+release@googlegroups.com>
Build-Depends: curl, ca-certificates, debhelper (>= 8.0.0), dh-systemd (>= 1.5)
Standards-Version: 3.9.4
Homepage: https://kubernetes.io
Vcs-Git: https://github.com/kubernetes/kubernetes.git
Vcs-Browser: https://github.com/kubernetes/kubernetes

Package: kubelet
Architecture: {{ .BuildArch }}
Depends: iptables (>= 1.4.21), kubernetes-cni (>= {{ index .Dependencies "kubernetes-cni" }}), iproute2, socat, util-linux, mount, ebtables, ethtool, conntrack, ${misc:Depends}
Description: Kubernetes Node Agent
 The node agent of Kubernetes, the container cluster manager
